import os
import sys
from os import pipe, fdopen, path
from subprocess import Popen


class CVProgramLauncher:
    def __init__(self, team_color):
        self.team_color = team_color
        self._cv_process = None

    def __enter__(self):
        fd_input, fd_output = pipe()
        self._input_fd = fdopen(fd_input)
        self._cv_process = Popen(
            [
                "/Users/cytadel/Library/Caches/pypoetry/virtualenvs/polystar.robots-at-robots-UuVcm5u0-py3.7/bin/python3",
                "/Users/cytadel/polystar/cv-code/robots-at-robots/research/demos/demo_pipeline.py",
                str(fd_output),
                self.team_color,
            ],
            env={
                'PYTHONPATH': '/Users/cytadel/polystar/cv-code/robots-at-robots:/Users/cytadel/polystar/cv-code/common',
                'PATH': os.environ['PATH'] + ';sbin',
            }
        )
        return self

    def __exit__(self, exc_type, exc_val, exc_tb):
        self._cv_process.terminate()
        self._cv_process.wait()

    def get_next_position(self):
        return self._input_fd.readline()
